﻿package com.oxylusflash.comingSoon 
{
	
	//importing classes
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.BlurFilter;
	import flash.net.URLRequest;
	import flash.text.TextField;
	import com.oxylusflash.zorked.URLNavigator;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Loader;
	import caurina.transitions.Tweener;
	import com.oxylusflash.events.ParamEvent;
	
	/**
	 * @version 28.05.2010
	 * @author bogdan@oxylus.ro
	 */
	
	public class SocialLink extends Sprite
	{
		//declaring variables
		private var target:String;
		private var link:String;
		private var imgLoader:Loader;
		private var Img:Sprite;
		private var bmp:BitmapData;
		private var hitMC:Sprite;
		private var oh:Number;
		private var ow:Number;
		private var reflection:Reflection;
		
		//constructor with parameters
		public function SocialLink(a:XML) 
		{
			
			this.buttonMode = true;
			addEventListener(MouseEvent.ROLL_OVER, onMouseHandler);
			addEventListener(MouseEvent.ROLL_OUT, onMouseHandler);
			addEventListener(MouseEvent.CLICK, onMouseHandler);
			link = a.link.text();
			target = a.target.text();
			
			imgLoader = new Loader();
			imgLoader.contentLoaderInfo.addEventListener(Event.INIT, imgLoader_initHandler);
			imgLoader.load(new URLRequest(a.icon.text()));
		}
		
		// handler for the image load complete event
		private function imgLoader_initHandler(e:Event):void 
		{
			
			ow = imgLoader.content.width;
			oh = imgLoader.content.height;
			bmp = new BitmapData(ow, oh, true, 0);
			bmp.draw(imgLoader.content);
			Img = new Sprite();
			Img.alpha = 0;
			Img.addChild(new Bitmap(bmp, "auto", true ));
			
			hitMC = new Sprite();
			hitMC.graphics.beginFill(0x000000, 1);
			hitMC.graphics.drawRect(0, 0, ow, oh);
			hitMC.graphics.endFill();
			hitMC.visible = false;
			addChild(hitMC);
			
			this.hitArea = hitMC;
			this.addChild(Img);
			
			Tweener.addTween(Img, { alpha:1, time: 0.3, transition: "easeoutquad" } );
			
			reflection = new Reflection(Img, this, 5,false,true);
			reflection.mouseEnabled = false;
			reflection.y = 25;
			//reflection.filters = [new BlurFilter(3,3,3)]
			addChild(reflection);
			
			var thumbLoadedEvent:ParamEvent = new ParamEvent("thumbloaded", {variable:null});
			dispatchEvent(thumbLoadedEvent);
			
		}
		
		//handler for the roll over, roll out and click events
		private function onMouseHandler(e:MouseEvent):void 
		{
			switch (e.type)
			{
				case "rollOver":
				{
					Tweener.addTween(Img, { y: -5 , time: 0.2, transition: "easeoutquad" } ); 
					Tweener.addTween(hitMC, { y: -5 , height:oh+5, time: 0.2, transition: "easeoutquad" } ); 
					break;
				}
				case "rollOut":
				{
					Tweener.addTween(Img, { y: 0 , time: 0.2, transition: "easeoutquad" } );
					Tweener.addTween(hitMC, { y: 0 ,height:oh, time: 0.2, transition: "easeoutquad" } );
					break;
				}
				case "click": URLNavigator.ChangePage(link, target || "_blank")
			}
		}
		
	}

}