package com.oxylusflash.events
{
	import flash.events.Event;
	
	public class ParamEvent extends Event
	{		
		public static const UPDATEMATERIAL:String = "updatematerial";
		public static const UPDATEREFLECTION:String = "updatereflection";		
		public static const THUMBLOADED:String = "thumbloaded";		
		public static const BUTTONCLICK:String = "buttonclick";		
		public static const ROTATECUBE:String = "rotatecube";	
		public static const LOGOLOADED:String = "logoloaded";
		
		private var _params:Object;
		
		/**
		 * Event with parameters.
		 * @param	type	Event type.
		 * @param	p		Parameters object.
		 */
		public function ParamEvent(type:String, p:Object)
		{
			super(type);			
			_params = p;
		}
		
		/**
		 * Event params. 
		 */
		public function get params():Object { return _params; }
	}
}