package com.oxylusflash.comingSoon
{
	//import classes
	import flash.display.Sprite;
	/**
	 * @version 28.05.2010
	 * @author bogdan@oxylus.ro
	 */
	public class MainBackground extends Sprite
	{
		//declaring variables
		public var border:Sprite;
		public var blackGradient:Sprite;
		public var whiteGradient:Sprite;
		public var middleGradient:Sprite;
		public var buttonsHolder:Sprite;
		
		//null constructor
		public function MainBackground() 
		{
			
		}
		
		//resize the gradients
		public function resize(moduleWidth:Number, moduleHeight:Number):void
		{
			border.width = moduleWidth;
			border.height = moduleHeight;
			blackGradient.width = moduleWidth;
			blackGradient.height = Math.round(moduleHeight / 2);
			middleGradient.width = moduleWidth - 2;
			middleGradient.y = Math.round(blackGradient.height - middleGradient.height);
			whiteGradient.y = blackGradient.height;
			whiteGradient.height = Math.round(moduleHeight / 2)-1;
			whiteGradient.width = moduleWidth - 2;
	
		}
		
		//resize the gradients when there is not count down timer
		public function resizeNoTimer(moduleWidth:Number, moduleHeight:Number):void
		{
			blackGradient.height = Math.round(moduleHeight / 2) + 96;
			middleGradient.y = Math.round(blackGradient.height - middleGradient.height);
			whiteGradient.y = blackGradient.height;
			whiteGradient.height = Math.round(moduleHeight / 2)-97;
			whiteGradient.width = moduleWidth-2;
		}
		
		//resize the gradients for the about and contact modules
		public function resizeSmall(moduleWidth:Number, moduleHeight:Number):void
		{
			border.width = moduleWidth;
			border.height = moduleHeight;
			blackGradient.width = moduleWidth;
			blackGradient.height = 56;
			middleGradient.width = moduleWidth - 2;
			middleGradient.y = Math.round(blackGradient.height - middleGradient.height);
			whiteGradient.y = blackGradient.height;
			whiteGradient.height = Math.round(moduleHeight - blackGradient.height-1);
			whiteGradient.width = moduleWidth - 2;
		}
	}

}