﻿package com.oxylusflash.comingSoon 
{
	import caurina.transitions.Tweener;
	import caurina.transitions.properties.ColorShortcuts;
	ColorShortcuts.init();
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.text.StyleSheet;
	import flash.text.TextField;
	import com.oxylusflash.events.ParamEvent;
	/**
	 * @version 28.05.2010
	 * @author bogdan@oxylus.ro
	 */
	public class SendButton extends Sprite
	{
		//declaring variables
		private var sheet:StyleSheet;
		public var outState:Sprite;
		public var overState:Sprite;
		public var Text:TextField;
		private var rollOutColor:Number;
		
		//constructor with parameters
		public function SendButton() 
		{
			
		}
		
		//set the textfield and color
		public function setData(text:String, rOutColor:Number, cssData:String) :void
		{
			sheet = new StyleSheet();
			sheet.parseCSS(cssData);
			Tweener.addTween(Text, { _color:rOutColor, time: 0.3, transition: "easeoutquad" });
			rollOutColor = rOutColor;
		
			
			Text.styleSheet = sheet;
			Text.autoSize = "left";
			Text.htmlText = text;
			resize(Math.round(Text.width) );
			Text.mouseEnabled = false;
			this.buttonMode = true;
			this.addEventListener(MouseEvent.ROLL_OVER, onMouseHandler);
			this.addEventListener(MouseEvent.ROLL_OUT, onMouseHandler);
			overState.alpha = 0;
			
		}
		
		private function updRefEvent():void 
		{
			var sendBtnEvent:ParamEvent = new ParamEvent("updatereflection", {variable:null});
			dispatchEvent(sendBtnEvent);
		}
		
		//resize the send button
		private function resize(newW:Number):void
		{
			outState.width = newW + 6;
			overState.width = outState.width;
			
		}
		
		//handler for the roll over and roll out events
		private function onMouseHandler(e:MouseEvent):void 
		{
			switch (e.type)
			{
				case "rollOver":
				Tweener.addTween(overState, { alpha:1, time: 0.3,onUpdate:updRefEvent, transition: "easeoutquad" });
				
				break;
				
				case "rollOut":
				Tweener.addTween(overState, { alpha:0, time: 0.3,onUpdate:updRefEvent, transition: "easeoutquad" });
				break;
				
			}
		}
	}

}