package com.oxylusflash.ui {
	import caurina.transitions.Tweener;
	import flash.display.Sprite;
	import flash.events.Event;
	
	
	public class MouseStateElement extends Sprite {
		public var normalState:Sprite;
		public var overState:Sprite;
		
		public function MouseStateElement():void { 
			this.scaleX = 1;
			this.scaleY = 1;
			
			overState.alpha = 0;
		}
		
		override public function get width():Number {
			return normalState.width;
		}
		override public function set width(value:Number):void {
			normalState.width 	= Math.round(value);
			overState.width 	= normalState.width;
		}
		
		override public function get height():Number {
			return normalState.height;
		}
		override public function set height(value:Number):void {
			normalState.height 	= Math.round(value);
			overState.height 	= normalState.height;
		}
		
		public function showOverState():void {
			Tweener.addTween(overState, { alpha:1, time: 0.3, transition: "easeoutquad" });
			
		}
		public function hideOverState():void {
			Tweener.addTween(overState, { alpha:0, time: 0.3, transition: "easeoutquad" });
		}
	}
}